const int N = sizeof(unsigned) * 8;

unsigned rot(unsigned val, int n)
{
	return n > 0 ? val << n | val >> (N - n)
		    : val >> -n | val << ((N + n) & (N - 1));
}

unsigned s2b(char *s)
{
	unsigned n;
	for (n = 0; *s; n |= *s++ & 1)
		n <<= 1;
	return n;
}

char *b2s(unsigned n, char *s)
{
	s[N] = '\0';
	for (int i = N - 1; i >= 0; n >>= 1)
		s[i--] = (n & 1) | '0';
	return s;
}

#include <iostream>

using namespace std;

int main()
{
	char s[N + 1];
	cin.getline(s, N + 1);
	unsigned n = s2b(s);
	cout << endl;
	for (int i = 0; i < N; i++) {
		cout << b2s(rot(n,  i), s) << "\t";
		cout << b2s(rot(n, -i), s) << endl;
	}
	return 0;
}
