// Подреди във възходящ ред масив от R1 (R1 > 2) думи със знак, указани от R0
// Ingo Wegener: Bottom-up Heapsort, a new variant of Heapsort beating, on an
// average, Quicksort (if n is not very small), Theoretical Comp. Science '93

/* Пирамида – двоично дърво, в което родителят е не по-малък от потомците си.
void downHeap(int *a, int k, int n)	// Прегледай поддървото и премести
{					// най-големия възел в корена му
	int i, tmp;

	n--;					// Премини към база 0
	for (tmp = a[k]; k <= n / 2; k = i) {	// В корена запомни родителя
		i = 2 * k;			// Ляв потомък
		if (i < n && a[i] < a[i+1])	// Ако има десен, сравни го с
			i++;			// левия и избери по-големия
		if (tmp >= a[i])	// Ако родителят е по-голям или равен
			break;		// на най-големия потомък, клонът е OK
		a[k] = a[i];		// Иначе потомъкът застава на мястото
	}				// на родителя
	a[k] = tmp;	// Накрая родителят си разменя мястото с най-големия
}			// потомък, освен ако е по-голям от всички потомци

void heapSort(int *a, int n)		// Пирамидално сортиране (tri par tas)
{					// Сортиращо дърво, heap, tas: пирамида
	int i, tmp;

	for (i = n / 2; i >= 0; i--)	// Създай сортиращо дърво (максималният
		downHeap(a, i, n);	// елемент на масива ще бъде в корена)
	for (i = n - 1; i > 0; i--) {
		tmp = a[i];		// Размени местата на максимума
		a[i] = a[0];		// и последния елемент на масива
		a[0] = tmp;
		downHeap(a, 0, i);	// Препострой сортиращото дърво за
	}				// неотсортираната част от масива
}
*/

.global heapSort	        //void heapSort(int *a, int n)	 //R0, R1
heapSort:		       // {	| int i, tmp;		// R3 (R1), R3
	STMFD	SP!,{R4-R7,LR}//Съхрани използваните регистри (ARM IHI 0042F)
	MOV	R3,R1,LSR #1 //		| for (i = n / 2; i >= 0; i--)
	SUB	R1,R1,#1    //n--	|
L1:	MOV	R2,R3	   // i		|
	BL	DOWNHEAP  //		|	  downHeap(a, i, n); //R0,R2,R1
	SUBS	R3,R3,#1 //		|	  //		  i--)
	BHS	L1	//		|	  //	  i >= 0;
L2:	LDR	R4,[R0]	//		| for (i = n - 1; i > 0; i--) {//R1 = i
	LDR	R3,[R0,R1,LSL #2]//	|	  tmp = a[i];
	STR	R4,[R0,R1,LSL #2]//	|	  a[i] = a[0];
	STR	R3,[R0]	//		|	  a[0] = tmp;
	MOV	R2,#0	// k = 0	|
	SUB	R1,R1,#1// i-- (n--)	|	  downHeap(a, 0, i); //R0,R2,R1
	BL	DOWNHEAP//		| }
	CMP	R1,#0	//	__}		  //	  i > 0;
	BNE	L2	//     /  void downHeap(int *a, int k, int n)//R0,R2,R1
	LDMFD	SP!,{R4-R7,PC}// /{	| int i,tmp;/*R4,5*/n--;//вече намалено
DOWNHEAP: LDR	R5,[R0,R2,LSL #2]//	| for (tmp = a[k]; k <= n / 2; k = i) {
L3:	CMP	R2,R1,LSR #1//k <= n / 2 ?
	BHI	L5	// ако не, край на цикъла
	MOV	R4,R2,LSL #1//		|	  i = 2 * k;
	CMP	R4,R1	//		|	  if (i < n
	BHS	L4	//		|
	ADD	R6,R0,R4,LSL #2//	|		    &&
	LDMIA	R6,{R6,R7}//		|
	CMP	R6,R7	//		|		       a[i] < a[i+1])
	ADDLT	R4,R4,#1//		|		  i++;
L4:	LDR	R6,[R0,R4,LSL #2]//	|
	CMP	R5,R6	//		|	  if (tmp >= a[i])
	BGE	L5	//		|		  break;
	STR	R6,[R0,R2,LSL #2]//	|	  a[k] = a[i];
	MOV	R2,R4	// k = i	| }
	B	L3
L5:	STR	R5,[R0,R2,LSL #2]//	| a[k] = tmp;
	BX	LR	//	  }
