#ifdef VERIFY

void downHeap(int *a, int k, int n)
{
	int i, tmp;

	n--;
	for (tmp = a[k]; k <= n / 2; k = i) {
		i = 2 * k;
		if (i < n && a[i] < a[i+1])
			i++;
		if (tmp >= a[i])
			break;
		a[k] = a[i];
	}
	a[k] = tmp;
}

void heapSort(int *a, int n)
{
	int i, tmp;

	for (i = n / 2; i >= 0; i--)
		downHeap(a, i, n);
	for (i = n - 1; i > 0; i--) {
		tmp = a[i];
		a[i] = a[0];
		a[0] = tmp;
		downHeap(a, 0, i);
	}
}
#else

#ifdef __i386__
# define ATTRIB	__attribute__((regparm(3)))
#else
# define ATTRIB
#endif

void ATTRIB heapSort(int *, int);

#endif

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define SIZE	35

int main()
{
	int a[SIZE], i;

	srand48(time(NULL));
	for (i = 0; i < SIZE; i++)
		a[i] = mrand48();
	heapSort(a, SIZE);
	for (i = 0; i < SIZE; i++)
		printf("%2d: %11d\n", i, a[i]);
	return 0;
}
