// Да се напише подпрограма, която да записва от адрес, подаден в регистър R1,
// низ тип ASCIIZ в десетичен формат без водещи нули и с разделител между
// байтовете точка, получен от IP-адрес (IPv4), подаден в регистър R0.

.global	putipstr
putipstr:
	STMFD	SP!,{R4,R5,LR}	//Съхрани използваните регистри (ARM IHI 0042F)
	LDR	R2,='.' << 24 |'.' << 16 | '.' << 8
L1:	MOV	R3,R0,LSR #24	// Зареди следващ байт (от старши към младши)
	MOV	R0,R0,LSL #8	// Измести IP-адреса с 1 байт наляво
	CMP	R3,#9		// Само единици ли имаме?
	BLS	L2		// Да, запиши ги направо, без нули пред тях
	CMP	R3,#99		// Не, само десетици и единици ли имаме?
	MOVHI	R4,#100		// Не, получи и запиши цифрите на стотиците
	BLHI	DIGIT
	MOV	R4,#10		// Направи същото и с десетиците
	BL	DIGIT
L2:	ADD	R3,R3,#'0'	// Преобразувай цифрата на единиците в ASCII
	STRB	R3,[R1],#1	// Запиши ASCII-кода на единиците
	MOVS	R2,R2,LSR #8	// Последен байт?
	STRB	R2,[R1],#1	// (Запиши разделителя или терминатора в низа)
	BNE	L1		// Не: премини към обработка на следващия байт
	LDMFD	SP!,{R4,R5,PC}	//Да: възстанови регистрите, върни управлението

DIGIT:	UDIV	R5,R3,R4	// R5 = поредната цифра
	MUL	R4,R5,R4
	SUB	R3,R3,R4	// R3 = следващите цифри във вид на остатък
	ADD	R5,R5,#'0'	// Преобразувай цифрата в ASCII-код
	STRB	R5,[R1],#1	// и я запиши в низа
	BX	LR
