#include <stdio.h>

unsigned long long strtoull(const char *, char **, int);

int main()
{
	unsigned long long mult1, mult2;
	unsigned m10, m11, m20, m21, p0, p1, p2, p3;
	char s[BUFSIZ];

	setvbuf(stdout, NULL, _IONBF, 0);
	printf("Multiplicand 1 (64-bit hex): ");
	mult1 = strtoull(fgets(s, sizeof(s), stdin), NULL, 16);
	printf("Multiplicand 2 (64-bit hex): ");
	mult2 = strtoull(fgets(s, sizeof(s), stdin), NULL, 16);
	m10 = (unsigned) mult1;
	m11 = (unsigned)(mult1 >> 32);
	m20 = (unsigned) mult2;
	m21 = (unsigned)(mult2 >> 32);
	asm(
#ifdef __i386__
		"mov  %4,%%eax\n"
		"mov  %5,%%ebx\n"
		"mov  %6,%%ecx\n"
		"mov  %7,%%edx\n"
		"call _um64x64\n"
		"mov  %%eax,%0\n"
		"mov  %%ebx,%1\n"
		"mov  %%ecx,%2\n"
		"mov  %%edx,%3\n"
#elif defined __mips__
		"lw   $4,%4\n"
		"lw   $5,%5\n"
		"lw   $6,%6\n"
		"lw   $7,%7\n"
		"bal um64x64\n"
		"sw   $4,%0\n"
		"sw   $5,%1\n"
		"sw   $6,%2\n"
		"sw   $7,%3\n"
#elif defined __riscv
		"lw   a0,%4\n"
		"lw   a1,%5\n"
		"lw   a2,%6\n"
		"lw   a3,%7\n"
		"call um64x64\n"
		"sw   a0,%0\n"
		"sw   a1,%1\n"
		"sw   a2,%2\n"
		"sw   a3,%3\n"
#elif defined __xtensa__
		"l32i a2,%4\n"
		"l32i a3,%5\n"
		"l32i a4,%6\n"
		"l32i a5,%7\n"
		"movi a0,um64x64\n"
		"callx0 a0\n"
		"s32i a2,%0\n"
		"s32i a3,%1\n"
		"s32i a4,%2\n"
		"s32i a5,%3\n"
#elif defined __nios2__
		"ldw  r4,%4\n"
		"ldw  r5,%5\n"
		"ldw  r6,%6\n"
		"ldw  r7,%7\n"
		"call um64x64\n"
		"stw  r4,%0\n"
		"stw  r5,%1\n"
		"stw  r6,%2\n"
		"stw  r7,%3\n"
#elif defined __microblaze__
		"lwi  r5,%4\n"
		"lwi  r6,%5\n"
		"lwi  r7,%6\n"
		"lwi  r8,%7\n"
		"brlid r15,um64x64\n"
		"nop\n"
		"swi  r5,%0\n"
		"swi  r6,%1\n"
		"swi  r7,%2\n"
		"swi  r8,%3\n"
#elif defined __or1k__
		"l.lwz r3,%4\n"
		"l.lwz r4,%5\n"
		"l.lwz r5,%6\n"
		"l.lwz r6,%7\n"
		"l.jal um64x64\n"
		"l.nop 0\n"
		"l.sw  %0,r3\n"
		"l.sw  %1,r4\n"
		"l.sw  %2,r5\n"
		"l.sw  %3,r6\n"
#elif defined __s390__
		"l    2,%4\n"
		"l    3,%5\n"
		"l    4,%6\n"
		"l    5,%7\n"
		"st   14,8(15)\n"
		"bras 14,um64x64\n"
		"l    14,8(15)\n"
		"st   2,%0\n"
		"st   3,%1\n"
		"st   4,%2\n"
		"st   5,%3\n"
#elif defined _AIX && defined _POWER
		"lwz  3,%4\n"
		"lwz  4,%5\n"
		"lwz  5,%6\n"
		"lwz  6,%7\n"
		"bl um64x64\n"
		"stw  3,%0\n"
		"stw  4,%1\n"
		"stw  5,%2\n"
		"stw  6,%3\n"
#elif defined __powerpc__ || defined __ppc__ || defined __PPC__
		"lwz  r3,%4\n"
		"lwz  r4,%5\n"
		"lwz  r5,%6\n"
		"lwz  r6,%7\n"
		"bl um64x64\n"
		"stw  r3,%0\n"
		"stw  r4,%1\n"
		"stw  r5,%2\n"
		"stw  r6,%3\n"
#elif defined __sparc
		"ld   %4,%%o0\n"
		"ld   %5,%%o1\n"
		"ld   %6,%%o2\n"
		"ld   %7,%%o3\n"
		"call um64x64\n"
		"nop\n"
		"st   %%o0,%0\n"
		"st   %%o1,%1\n"
		"st   %%o2,%2\n"
		"st   %%o3,%3\n"
#elif defined __m88k__
		"ld   r2,%4\n"
		"ld   r3,%5\n"
		"ld   r4,%6\n"
		"ld   r5,%7\n"
		"bsr _um64x64\n"
		"st   r2,%0\n"
		"st   r3,%1\n"
		"st   r4,%2\n"
		"st   r5,%3\n"
#elif defined __vax__ && defined __ultrix__
		"movl %4,r0\n"
		"movl %5,r1\n"
		"movl %6,r2\n"
		"movl %7,r3\n"
		"calls $0,_um64x64\n"
		"movl r0,%0\n"
		"movl r1,%1\n"
		"movl r2,%2\n"
		"movl r3,%3\n"
#elif defined __vax__
		"movl %4,%%r0\n"
		"movl %5,%%r1\n"
		"movl %6,%%r2\n"
		"movl %7,%%r3\n"
		"calls $0,um64x64\n"
		"movl %%r0,%0\n"
		"movl %%r1,%1\n"
		"movl %%r2,%2\n"
		"movl %%r3,%3\n"
#elif defined we32000
		"movw %4,%%r0\n"
		"movw %5,%%r1\n"
		"movw %6,%%r2\n"
		"movw %7,%%r3\n"
		"jsb um64x64\n"
		"movw %%r0,%0\n"
		"movw %%r1,%1\n"
		"movw %%r2,%2\n"
		"movw %%r3,%3\n"
#elif defined __mc68020
		"movel %4,%%d0\n"
		"movel %5,%%d1\n"
		"movel %6,%%d2\n"
		"movel %7,%%d3\n"
		"bsr um64x64\n"
		"movel %%d0,%0\n"
		"movel %%d1,%1\n"
		"movel %%d2,%2\n"
		"movel %%d3,%3\n"
#elif defined __cris__
		"move.d %4,$r10\n"
		"move.d %5,$r11\n"
		"move.d %6,$r12\n"
		"move.d %7,$r13\n"
		"bsr um64x64\n"
		"nop\n"
		"move.d $r10,%0\n"
		"move.d $r11,%1\n"
		"move.d $r12,%2\n"
		"move.d $r13,%3\n"
#elif defined __sh__
		"mov.l %4,r4\n"
		"mov.l %5,r5\n"
		"mov.l %6,r6\n"
		"mov.l %7,r7\n"
		"mov.l 0f,r0\n"
		"bra 1f\n"
		"nop\n"
		".align 2\n"
		"0: .long um64x64\n"
		"1: jsr @r0\n"
		"nop\n"
		"mov.l r4,%0\n"
		"mov.l r5,%1\n"
		"mov.l r6,%2\n"
		"mov.l r7,%3\n"
#elif defined __hppa
		"ldw  %4,%%r26\n\t"
		"ldw  %5,%%r25\n\t"
		"ldw  %6,%%r24\n\t"
		"ldw  %7,%%r23\n\t"
		".import um64x64,code\n\t"
		"bl um64x64,%%r2\n\t"
		"nop\n\t"
		"stw  %%r26,%0\n\t"
		"stw  %%r25,%1\n\t"
		"stw  %%r24,%2\n\t"
		"stw  %%r23,%3\n"
#elif defined bfin
		"r0 = %4;\n"
		"r1 = %5;\n"
		"r2 = %6;\n"
		"r3 = %7;\n"
		"call _um64x64;\n"
		"%0 = r0;\n"
		"%1 = r1;\n"
		"%2 = r2;\n"
		"%3 = r3;\n"
#else /* defined __arm__ */
		"ldr  r0,%4\n"
		"ldr  r1,%5\n"
		"ldr  r2,%6\n"
		"ldr  r3,%7\n"
		"bl um64x64\n"
		"str  r0,%0\n"
		"str  r1,%1\n"
		"str  r2,%2\n"
		"str  r3,%3\n"
#endif
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
#ifdef __i386__
		: "%eax", "%ebx", "%ecx", "%edx"
#elif defined __mips__
		: "$4", "$5", "$6", "$7"
#elif defined __riscv
		: "a0", "a1", "a2", "a3"
#elif defined __xtensa__
		: "a2", "a3", "a4", "a5"
#elif defined __s390__
		: "2", "3", "4", "5"
#elif defined _AIX && defined _POWER
		: "3", "4", "5", "6"
#elif defined __powerpc__ || defined __ppc__ || defined __PPC__ || defined __or1k__
		: "r3", "r4", "r5", "r6"
#elif defined __m88k__
		: "r2", "r3", "r4", "r5"
#elif defined __nios2__
		: "r4", "r5", "r6", "r7"
#elif defined __microblaze__
		: "r5", "r6", "r7", "r8"
#elif defined __sparc__
		: "%o0", "%o1", "%o2", "%o3"
#elif defined __mc68020
		: "%d0", "%d1", "%d2", "%d3"
#elif defined __cris__
		: "$r10", "$r11", "$r12", "$r13"
#elif defined __sh__
		: "r0", "r4", "r5", "r6", "r7"
#elif defined __hppa
		: "%r26", "%r25", "%r24", "%r23"
#elif defined we32000
		: "%r0", "%r1", "%r2", "%r3"
#elif defined bfin
		: "R0", "R1", "R2", "R3"
#elif defined __vax__ && !defined __ultrix__
		: "%r0", "%r1", "%r2", "%r3"
#else /* ARM / VAX Ultrix */
		: "r0", "r1", "r2", "r3"
#endif
	);
	printf("The product: %08X%08X%08X%08X\n", p3, p2, p1, p0);
	return 0;
}
