// http://codeproject.com/Tips/618570/UInt-Multiplication-Squaring (Jacob F.W.)

void mult64to128(unsigned long long u, unsigned long long v, unsigned long long &h, unsigned long long &l)
{
	unsigned long long u1 = u & 0xFFFFFFFF;
	unsigned long long v1 = v & 0xFFFFFFFF;
	unsigned long long t = u1 * v1;
	unsigned long long w3 = t & 0xFFFFFFFF;
	unsigned long long k = t >> 32;
	u >>= 32;
	t = u * v1 + k;
	k = t & 0xFFFFFFFF;
	unsigned long long w1 = t >> 32;
	v >>= 32;
	t = u1 * v + k;
	k = t >> 32;
	h = u * v + w1 + k;
	l = (t << 32) + w3;
}

#include <iostream>
#include <iomanip>

using namespace std;

int main()
{
	unsigned long long m1, m2, p0, p1;
	cout << "Multiplicand 1 (64-bit hex): ";
	cin >> hex >> m1;
	cout << "Multiplicand 2 (64-bit hex): ";
	cin >> hex >> m2;
	mult64to128(m1, m2, p1, p0);
	cout << "The product: " << hex << uppercase << setfill('0') << setw(16) << p1 << setw(16) << p0 << endl;
	return 0;
}
