#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define SIZE 26

#ifdef __i386__
# define ATTRIB	__attribute__((regparm(3)))
#else
# define ATTRIB
#endif

#ifdef VERIFY
# define getvlq getVLQ
# define putvlq putVLQ
#else
  unsigned ATTRIB getvlq(unsigned char **);
  unsigned char * ATTRIB putvlq(unsigned value, unsigned char *);
#endif

unsigned getVLQ(unsigned char **src)
{
    unsigned char c, *p = *src;
    unsigned value = *p++;
    if (value & 0x80) {
	value &= 0x7f;
	do
	    value = (value << 7) + ((c = *p++) & 0x7f);
	while (c & 0x80);
    }
    *src = p;
    return value;
}

unsigned char *putVLQ(unsigned value, unsigned char *dest)
{
    unsigned buffer = value & 0x7f;
    while ((value >>= 7) > 0) {
	buffer <<= 8;
	buffer |= 0x80;
	buffer += value & 0x7f;
    }
    for ( ; ; ) {
	*dest++ = (unsigned char)buffer;
	if (buffer & 0x80)
	    buffer >>= 8;
	else
	    return dest;
    }
}

int main()
{
	unsigned values[SIZE], i;
	unsigned char s[SIZE * sizeof(unsigned)], *p;

	srand48(time(NULL));
	for (p = s, i = 0; i < SIZE; i++) {
		values[i] = (unsigned)mrand48() >> (i + 4);
		p = putvlq(values[i], p);
	}
	for (p = s, i = 0; i < SIZE; i++)
		printf("%7X ===> %X\n", values[i], getvlq(&p));
	return 0;
}
